﻿/*---------------------------------------------------------------------------//
 RAWR - Player v0.2.1 - Main

 © 2007-2008, RAWR-Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
 (CC) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: contact[at]rawr-designs.com
	Forum: http://www.rejetto.com/forum/index.php?board=34.0
 	Homepage: http://rawr-designs.com
//---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------//
 Set variables for the player.
//---------------------------------------------------------------------------*/
var volume, id3Data, gBL, gBT, myMedia, myMediaDuration, myMediaPosition, pbStatus;
var version = "v0.2.1";//Player version.
var pos = oldMouseX = oldSeekX = 0;
var percentage = "0.00%";
var percPause = false;
var counterActive = closingDown = seekIconActive = seekActive = false;
var playmethod = playmethod.toLowerCase();
var autoplay = autoplay ? autoplay.toLowerCase() : autostart.toLowerCase();

/*---------------------------------------------------------------------------//
 Cut up the file variable for id3 and context properties.
//---------------------------------------------------------------------------*/
var fileSliced = file.split("/");
var filePiece = fileSliced[fileSliced.length-1];

/*---------------------------------------------------------------------------//
 Set the default volume, limit the volume variable to max and minimum.
//---------------------------------------------------------------------------*/
if (!volume) {
	volume = 50;
} else if (volume>100) {
	volume = 100;
} else if (volume<0) {
	volume = 0;
}
volumeBar.volMask._width = volume/100*volBackWidth;//Set volume bar width.

/*---------------------------------------------------------------------------//
 Detect if autoplay/start is enabled.
//---------------------------------------------------------------------------*/
if (autoplay == 1 || autoplay == "true" || autoplay == "on" || autoplay == "enabled") {
	initMedia();
} else {
	stop();
	stopBtn.icon._alpha = 30;
}

/*---------------------------------------------------------------------------//
 Detect the play method, change the button to suit.
//---------------------------------------------------------------------------*/
if (playmethod == "loop") {
	playmethod = "loop";
	tt.ttTxt = "Loop Play";
	methodBtn.singleIcon._visible = methodBtn.listIcon._visible = methodBtn.shuffleIcon._visible = false;
	methodBtn.loopIcon._visible = true;	
} else if (playmethod == "list") {
	playmethod = "list";
	tt.ttTxt = "List Play";
	methodBtn.singleIcon._visible = methodBtn.loopIcon._visible = methodBtn.shuffleIcon._visible = false;
	methodBtn.listIcon._visible = true;
} else if (playmethod == "shuffle") {
	playmethod = "shuffle";
	tt.ttTxt = "Shuffle";
	methodBtn.singleIcon._visible = methodBtn.loopIcon._visible = methodBtn.listIcon._visible = false;
	methodBtn.shuffleIcon._visible = true;
} else {
	playmethod = "single";
	tt.ttTxt = "Single Play";
	methodBtn.singleIcon._visible = true;
	methodBtn.loopIcon._visible = methodBtn.listIcon._visible = methodBtn.shuffleIcon._visible = false;
}

/*---------------------------------------------------------------------------//
 Initiate media.
//---------------------------------------------------------------------------*/
function initMedia() {
	if(!myMedia) {
		filetype=="flv"?initFLV():initMP3();
	} else {
		if(filetype=="flv") {
			if(pbStatus=="pause"||pbStatus=="play") {
				myMedia.pause();
			} else if(pbStatus=="seek") {
				myMedia.seek(pos);
			} else if(pbStatus=="stop") {
				myMedia.pause();
				pbStatus = "end";
			} else if(pbStatus=="end") {
				initFLV();
			} 
		} else {
			pbStatus=="play"||pbStatus=="seek"?myMedia.start(pos):myMedia.stop();
		}
	}
	counterActive = seekIconActive = true;
	playPauseSwap();
	fadeFunc(stopBtn.icon,"in",100);
	fadeFunc(progressBar.playStatus,"in",100);
}
function initMP3() {
	myMedia = new Sound();
	myMedia.loadSound(file, true);
	myMedia.setVolume(volume);
	myMedia.onID3 = function() {
		songName = myMedia.id3.songname;
		songArtist = myMedia.id3.artist;
		songAlbum = myMedia.id3.album;
		if (songName.length<1 || songName == undefined)	songName = "No Song Name";
		if (songArtist.length<1 || songArtist == undefined)	songArtist = "No Artist Name";
		if (songAlbum.length<1 || songAlbum == undefined) songAlbum = "No Album Name";
		id3Data = songName+" - "+songArtist+" - "+songAlbum;
		if (songName == "No Song Name" && songArtist == "No Artist Name" && songAlbum == "No Album Name") {
			id3Data = filePiece;
		}
		marqueeText(id3Data);
	}
}
function initFLV() {
	nc = new NetConnection();
	nc.connect(null);
	myMedia = new NetStream(nc);
	myMedia.setBufferTime(5);
	videoDisplay.videoPanel.attachVideo(myMedia);
	videoDisplay.videoPanel.smoothing = true;
	videoDisplay.videoPanel.deblocking = 5;
	this.createEmptyMovieClip("audio", 0);
	audio.attachAudio(myMedia);
	myMediaAudio = new Sound(audio);
	myMediaAudio.setVolume(volume);
	myMedia.play(file);
}
/*---------------------------------------------------------------------------//
 When player is playing, follow these events.
//---------------------------------------------------------------------------*/
onEnterFrame = function () {
	filetype=="flv"?manageFLV():manageMP3();
	counterFunc();//Initiate Counter.
	percentageFunc();//Initiate Percentage.
}
manageFLV = function () {
	myMediaPosition = myMedia.time*1000;
	myMedia.onMetaData = function(obj) {
		myMediaDuration = obj.duration*1000;
		/*
		var key:String;
		for (key in obj) {
			trace(key+": "+obj[key]);
			metaInfo += key+": "+obj[key]+"\n";
		}
		*/
	}
	gBL = myMedia.bytesLoaded;
	gBT = myMedia.bytesTotal;
	myMedia.onStatus = function(obj) {
		if(obj.code == "NetStream.Play.Stop") {
			if(playmethod == "loop") {
				myMedia.seek(0);
			} else {
				if (playmethod == "list") {
					changeMedia("next");
				} else if (playmethod == "shuffle") {
					changeMedia("shuffle");
				}
				myMedia.pause();
				pbStatus = "end";
				playPauseSwap("play");
				fadeFunc(progressBar.playStatus,"out",0);
				fadeFunc(stopBtn.icon,"out",30);
			}
		}
	}
}
manageMP3 = function () {
	myMediaPosition = myMedia.position;
	myMediaDuration = myMedia.duration;
	gBL = myMedia.getBytesLoaded();
	gBT = myMedia.getBytesTotal();
	myMedia.onSoundComplete = function() {
		pos = 0;
		if (playmethod == "loop") {
			initMedia();
		} else {
			if (playmethod == "list") {
				changeMedia("next");
			} else if (playmethod == "shuffle") {
				changeMedia("shuffle");
			}
			playPauseSwap("play");
			fadeFunc(progressBar.playStatus,"out",0);
		}
	}
}

/*---------------------------------------------------------------------------//
 Counter for playback status.
//---------------------------------------------------------------------------*/
counterFunc = function () {
	if(seekActive == false) {
		if (counterActive == true) {
			secsRaw = Math.round(myMediaPosition/1000);
			secs = secsRaw-int(secsRaw/60)*60;
			mins = Math.floor(secsRaw/60);
			if (int(secs)<10) secs = "0"+int(secs);
			if (int(mins)<10) mins = "0"+int(mins);
			counter = mins+":"+secs;
		} else {
			counter = "00:00";
		}
	}
}

/*---------------------------------------------------------------------------//
 Calculate percentage & set format.
//---------------------------------------------------------------------------*/
percentageFunc = function () {
	if (gBL != gBT) {
		//Set basic calculation vars for percentage.
		var p = (Math.round(gBL/gBT*10000)/100)+"%";
		var pIndexOf:Number = p.indexOf(".");
		var pLength:Number = p.length;
		var pSlice = p.slice(0, pLength-1);
		//Create percentage display style.
		if (pIndexOf == -1 && pLength != 4) {
			if (pLength == 3) {
				percentage = pSlice+".0%";
			} else if (pLength == 2) {
				percentage = pSlice+".00%";
			}
		} else if (pIndexOf == 1 && pLength == 4) {
			percentage = pSlice+"0%";
		} else if (pIndexOf == 2 && pLength == 6) {
			percentage = p.slice(0, pLength-2)+"%";
		} else {
			pSlice != "NaN" ? percentage = p : percentage = "0%";
		}
		progressBar.loadStatus._width = percentage.slice(0, percentage.length-1)*statusWidth;
	} else if (gBL == gBT) {//If percentage = 100% Show the total time.
		durationFunc();
		percentage = duration;
		progressBar.loadStatus._width = statusWidth*100;	
	} else {
		percentage = "0.00%";
	}
}

/*---------------------------------------------------------------------------//
 Calculate duration.
//---------------------------------------------------------------------------*/
durationFunc = function (rtrn:Boolean, time) {
	!rtrn ? secsRaw = Math.round(myMediaDuration/1000) : secsRaw = Math.round(time);
	secs = secsRaw-int(secsRaw/60)*60;
	mins = Math.floor(secsRaw/60);
	if (int(secs)<10) secs = "0"+int(secs);
	if (int(mins)<10) mins = "0"+int(mins);
	if (!rtrn) duration = mins+":"+secs; else return mins+":"+secs;
}

/*---------------------------------------------------------------------------//
 Setup and handle the progress bar.
//---------------------------------------------------------------------------*/
progressBar.onEnterFrame = function() {
	filetype=="flv"?manageFLV():manageMP3();
	//Set the new width for playStatus.
	newWidth = Math.round(myMediaPosition/(myMediaDuration/Math.round((gBL/gBT)*100))*(this.Bg._width-(this.Bg._width-this.progressBg._width))/100);
	if (this.playStatus._width<newWidth || newWidth == 0 && this.playStatus._width != 0) {
		this.playStatus._width = newWidth;
		if(seekIconActive)this.seekIcon._x = this.playStatus._width+((this._width-this.progressBg._width)/2);
	}
}
progressBar.onPress = function() {
	seekIconActive = false;
	seekActive = true;
	this.progressBg.onEnterFrame = function() {
		if(oldMouseX == 0)oldMouseX = progressBar._xmouse;//Set the onpress mouse x.
		if(oldSeekX == 0)oldSeekX = progressBar.seekIcon._x = progressBar._xmouse;//Set the onpress seek x.
		newPos = oldSeekX+(progressBar._xmouse-oldMouseX);//Set new position.
		//Check and fix the new position.
		if (newPos>progressBar.loadStatus._width+((progressBar._width-this._width)/2)) {
			newPos = progressBar.loadStatus._width+((progressBar._width-this._width)/2)-2;
		} else if (newPos<((progressBar._width-this._width)/2)) {
			newPos = (progressBar._width-this._width)/2;
		}
		progressBar.seekIcon._x = newPos;//Set seekIcon position.
		counter = durationFunc(true, myMediaDuration/100000*((progressBar.seekIcon._x-((progressBar._width-this._width)/2))/progressBar.loadStatus._width*100));
	}
}
progressBar.onRelease = progressBar.onReleaseOutside = function () {
	seekIconActive = true;
	seekActive = false;
	oldMouseX = oldSeekX = 0;//Clear 'Cache'.	
	delete this.progressBg.onEnterFrame;
	this.playStatus._width = this.seekIcon._x-((this._width-this.progressBg._width)/2);
	pos = myMediaDuration/100000*((this.seekIcon._x-((this._width-this.progressBg._width)/2))/this.loadStatus._width*100);
	pbStatus = "seek";
	initMedia();	
}

/*---------------------------------------------------------------------------//
 Setup and handle the volume bar.
//---------------------------------------------------------------------------*/
volumeBar.volBack.onPress = function() {
	this.onEnterFrame = function() {
		this._parent.volMask._width = this._xmouse;
		volume = this._xmouse/(volBackWidth/100);
		if (this._xmouse>volBackWidth) {
			volume = 100;
		} else if (this._xmouse<=0) {
			volume = 0;
		}
		myMedia.setVolume(volume);
		myMediaAudio.setVolume(volume);
	}
}
volumeBar.volBack.onRelease = volumeBar.volBack.onReleaseOutside = function () {
	delete this.onEnterFrame;
	ExternalInterface.call("playerVolume", volume);
}

/*---------------------------------------------------------------------------//
 Generic fade function for the playstatus.
//---------------------------------------------------------------------------*/
fadeFunc = function (obj, method, alpha) {
	obj.onEnterFrame = function() {
		if (this._alpha>alpha && method == "out") {
			this._alpha -= 2;
		} else if (this._alpha<alpha && method == "in") {
			this._alpha += 2;
		} else {
			delete this.onEnterFrame;
		}
	}
}

/*---------------------------------------------------------------------------//
 Marque for id3 or filename value.
//---------------------------------------------------------------------------*/
var container1Go:Boolean = true;
var container2Go:Boolean = false;
function marqueeText(id3Data) {
	this.createEmptyMovieClip("marqueeContainer1", 0);
	this.createEmptyMovieClip("marqueeContainer2", 1);
	marqueeContainer1.createTextField("txt1", l, 0, 31, id3Data.length*7, 18);
	marqueeContainer2.createTextField("txt2", l, 0, 31, id3Data.length*7, 18);
	txtF = new TextFormat();
	txtF.font = "Arial";
	txtF.size = 11;
	txtF.bold = true;
	txtF.color = color3;
	txtF.align = "center";
	txtF.embedFonts = true;
	marqueeContainer1.txt1.setNewTextFormat(txtF);
	marqueeContainer2.txt2.setNewTextFormat(txtF);
	marqueeContainer1.txt1.text = marqueeContainer2.txt2.text = id3Data;
	marqueeContainer1.txt1.selectable = marqueeContainer2.txt2.selectable = false;	
	marqueeContainer1._x = marqueeContainer2._x = Stage.width;	
	marqueeContainer1.onEnterFrame = function() {
		if (container1Go) this._x -= 1;
		if (this._x == -this._width) {
			this._x = Stage.width;
			container1Go = false;
		}
		if (this._x == Math.round(id3Bg1._width/1.7) - this._width) {
			container2Go = true;
		}			
	}
	marqueeContainer2.onEnterFrame = function() {
		if (container2Go) this._x -= 1;
		if (this._x == -this._width) {
			this._x = Stage.width;
			container2Go = false;
		}
		if (this._x == Math.round(id3Bg1._width/1.7) - this._width) {
			container1Go = true;
		}
	}
}
/*---------------------------------------------------------------------------//
 Play & pause button icon swap.
//---------------------------------------------------------------------------*/
function playPauseSwap(iconSet) {
	if(iconSet == "play") {
		playPauseBtn.playIcon._visible = true;
		playPauseBtn.pauseIcon._visible = false;
	} else {
		playPauseBtn.playIcon._visible = false;
		playPauseBtn.pauseIcon._visible = true;
	}
}

/*---------------------------------------------------------------------------//
 Change MP3 function for JavaScript.
//---------------------------------------------------------------------------*/
changeMedia = function (method) {
	if(closingDown == false)ExternalInterface.call("changeMedia",method);
	closingDown = true;
}

/*---------------------------------------------------------------------------//
 Setup context menu.
//---------------------------------------------------------------------------*/
var contextMenu:ContextMenu = new ContextMenu();
contextMenu.hideBuiltInItems();
function homeLink() {
	getURL("http://rawr-designs.com/?page=player", 'newwindow');
}
var pathURL = (file.substring(0, file.lastIndexOf("/"))).split(" ").join("%20") + "/";
var fileURL = (file.substring(file.lastIndexOf("/") + 1, file.length)).split(" ").join("%20");
function createDPLink() {
	rootDL = pathURL + "?playMedia=" + fileURL;
	System.setClipboard(rootDL);
}
function createDFLink() {
	createDPLink();
	rootDL = pathURL + fileURL;
	System.setClipboard(rootDL);
}
function createDLink() {
	createDFLink();
	rootDL = pathURL;
	System.setClipboard(rootDL);
}
var aboutLink:ContextMenuItem = new ContextMenuItem("About RAWR-Player-"+version+" ...", homeLink);
var dLink:ContextMenuItem = new ContextMenuItem("Copy Directory Link...", createDLink);
var dfLink:ContextMenuItem = new ContextMenuItem("Copy Direct-File Link...", createDFLink);
var dpLink:ContextMenuItem = new ContextMenuItem("Copy Direct-Play Link...", createDPLink);
contextMenu.customItems.push(aboutLink, dLink, dfLink, dpLink);
dLink.separatorBefore = true;
var context = context.toLowerCase();
if (context == 0 || context == "off" || context == "false" || context == "disabled") {
	dLink.enabled = dfLink.enabled = dpLink.enabled = false;
}
if(mode != "full")dpLink.enabled = false;
this.menu = contextMenu;